/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#include <boost/assign/list_of.hpp>

#include "experiment_group.h"

using namespace TkResolver;
using namespace Experimenter;
using namespace Db::Ui;

const static NameList selection_columns = boost::assign::list_of(Name("experiment_group_id"));
//const static NameList display_columns = boost::assign::list_of(Name("name"));
const static ComboColumnList display_columns = boost::assign::list_of
(ComboColumnInfo("Group",  boost::assign::list_of(Name("name")), 0));

ExperimentGroup:: ExperimentGroup(Db::Database * database)
  : DataSelectorCombo(database,
		      "experiment_group",
		      selection_columns)
{
  set_display_columns(display_columns);
  set_selection("experiment_group_id", database->choose_experiment_group());
}

Db::Id
ExperimentGroup:: get_experiment_group() const
{
  return get_selection().front()["experiment_group_id"];
}
