/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#include "libtkcommon/mbs.h"
#include "parameters.h"

using namespace TkResolver;
using namespace Experimenter;

Parameters:: Parameters(Db::Database * database)
  : Gtk::Frame("Parameters"),
    _experiment_group(database)
{
  Gtk::Table * table = Gtk::manage (new Gtk::Table(3, 2));
  table->set_spacings(4);

  table->attach(*Gtk::manage(new Gtk::Label("Experiment group",  Gtk::ALIGN_LEFT)), 0, 1, 0, 1, Gtk::FILL, Gtk::FILL);
  table->attach(*Gtk::manage(new Gtk::Label("Screen size",       Gtk::ALIGN_LEFT)), 0, 1, 1, 2, Gtk::FILL, Gtk::FILL);
  table->attach(*Gtk::manage(new Gtk::Label("Randomness source", Gtk::ALIGN_LEFT)), 0, 1, 2, 3, Gtk::FILL, Gtk::FILL);




  table->attach(_experiment_group, 1, 2, 0, 1, Gtk::EXPAND|Gtk::FILL, Gtk::FILL);
  table->attach(_screen_size,      1, 2, 1, 2, Gtk::EXPAND|Gtk::FILL, Gtk::FILL);
  table->attach(_randomness,       1, 2, 2, 3, Gtk::EXPAND|Gtk::FILL, Gtk::FILL);

  add(*table);

  show_all_children();
}

unsigned
Parameters:: get_width() const
{
  return _screen_size.get_width();
}

unsigned
Parameters:: get_height() const
{
  return _screen_size.get_height();
}

void
Parameters:: get_retriever_type(const Db::Id & experiment_group,
				TkString & retriever_type,
				bool & retriever_type_specified) const
{
  _randomness.get_randomness_source(retriever_type, retriever_type_specified);
}

Db::Id
Parameters:: get_experiment_group() const
{
  return _experiment_group.get_experiment_group();
}
