/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#ifndef __TK_EXP_INTENT_CHOOSER_H__
#define __TK_EXP_INTENT_CHOOSER_H__

#include <gtkmm.h>

#include "libtkcommon/tkvalue.h"
#include "intent_selector.h"

namespace TkResolver {
  namespace Experimenter {

    class Variables : public Gtk::Dialog
      {
      private:
	IntentSelector _intent_list;
	Gtk::CheckButton _ability_rating_set;
	Gtk::Adjustment _ability_rating;
	Gtk::HScale _ability_rating_slider;
	
	void refresh_active();
      public:
        Variables(Db::Database * database,
		  Gtk::Window & parent,
		  const Db::Id & experiment_group,
		  const Db::Code & dflt);
	Db::Code get_intent_code();
	TkDouble get_ability_rating();
      };
      
  } /* namespace Experimenter */
}; /* namespace TkResolver */




#endif /* __TK_EXP_INTENT_CHOOSER_H__ */
