/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2006 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#ifndef __TK_GNUPLOT_H__
#define __TK_GNUPLOT_H__

#include <wchar.h>
#include <iostream>
#include <ext/stdio_filebuf.h>

#include "analyser.h"

namespace TkResolver {
  namespace Analysis {
    
    class Gnuplot
      {
      private:
	typedef std::string Argument;
	typedef std::list<Argument> Arguments;
	typedef __gnu_cxx::stdio_filebuf<wchar_t> FileStream;
	typedef std::basic_ostream<wchar_t> OutputStream;
	
	FileStream   * _gnuplot_file;
	OutputStream * _gnuplot;
	
	static Arguments arguments(unsigned set_count, unsigned set_size);
	
	void spawn (const Arguments &arguments);
	void plot(const TkString &prefix, const OffsetList &offsets, bool first, bool last);
	void position_counts(const PositionCounts &position_counts);
	void position_function(const PositionCounts &position_counts,
			       const PositionFunction &positions);
	void offsets(const OffsetStatisticsSet &offset_stats);
	void statistics(const OffsetStatisticsSet &offset_stats);
	
	
      public:
	Gnuplot(const TkString &name, const OffsetStatisticsSet &stats);
	Gnuplot(const TkString &name_a, const OffsetStatisticsSet &stats_a,
		const TkString &name_b, const OffsetStatisticsSet &stats_b);
	~Gnuplot();
      };
    
  }; /* namespace Analysis */
}; /* namespace TkResolver */

#endif /* __TK_GNUPLOT_H__ */

