/* -*- c++ -*-
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#ifndef __TK_DATABASE_TYPES_H__
#define __TK_DATABASE_TYPES_H__

#include <mysql++/mysql++.h>

#include "libtkcommon/tkstring.h"
#include "libtkcommon/tkvalue.h"
#include "libtkrandom/random_types.h"
#include "libtkresolver/types.h"

namespace TkResolver {
  namespace Db {
    
    typedef my_ulonglong Id;
    typedef std::list<Id> IdList;
    typedef mysqlpp::Date Date;
    typedef mysqlpp::DateTime DateTime;
    typedef std::string Name;
    typedef std::list<Name> NameList;
    typedef mysqlpp::ColData Value;
    typedef std::map<Name, Value> Values;
    typedef mysqlpp::SQLString String;
    typedef TkValue<String> StringValue;
    typedef std::map<Name, StringValue> Parameters;
    typedef Parameters::value_type Parameter;
    typedef mysqlpp::mysql_type_info Type;
    typedef mysqlpp::Result DataSet;
    typedef mysqlpp::ResUse DataCursor;
    typedef mysqlpp::Row Row;
    typedef Name Code;
    typedef TkValue<Code> CodeValue;
    typedef std::list<Code> Codes;
    
  }; /* namespace Db */
}; /* namespace TkResolver */

#endif /* __TK_DATABASE_TYPES_H__ */
