/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#ifndef __TK_DB_UI_DATA_SELECTOR_COMBO_H__
#define __TK_DB_UI_DATA_SELECTOR_COMBO_H__

#include <gtkmm.h>

#include "data_selector.h"

namespace TkResolver {
  namespace Db {
    namespace Ui {
      
      typedef Gtk::CellLayout::SlotCellData SlotComboCellData;
      typedef DisplayColumnInfo<SlotComboCellData> ComboColumnInfo;
      typedef std::list<ComboColumnInfo> ComboColumnList;
      typedef DisplayColumnAdaptor<Gtk::CellLayout> ComboColumnAdaptor;
      
      class DataSelectorCombo : public DataSelector, public Gtk::ComboBox
	{
	private:
	  void create_widgets(const ComboColumnList & display_columns);
	  
	protected:
	  
	  DataSelectorCombo(Db::Database * database,
			    const Name & table_name,
			    const NameList & selection_columns);
	  // should be called immediately after constructor
	  void set_display_columns(const ComboColumnList & display_columns);
	  
	  virtual ModelIteratorList get_selected() const;
	  virtual void refreshed();
	  virtual void select(Gtk::TreeModel::iterator &iter);
	};
      
    } /* namespace Ui */
  } /* namespace Db */
}; /* namespace TkResolver */




#endif /* __TK_DB_UI_DATA_SELECTOR_COMBO_H__ */
