/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#ifndef __TK_DB_UI_LOGIN_H__
#define __TK_DB_UI_LOGIN_H__

#include <gtkmm.h>
#include <gconfmm.h>

#include "libtkcommon/tkstring.h"
#include "libtkcommon/debug.h"

namespace TkResolver {
  namespace Db {
    namespace Ui {
      
      class Login : public Gtk::Dialog
	{
	private:
	  Glib::RefPtr<Gnome::Conf::Client> _conf;

	  Gtk::Entry  _hostname;
	  Gtk::Entry  _database;
	  Gtk::Entry  _username;
	  Gtk::Entry  _password;

	public:
	  Login();
	  ~Login();
	  TkString get_hostname() const;
	  TkString get_database() const;
	  TkString get_username() const;
	  TkString get_password() const;
	};
      
    } /* namespace Ui */
  } /* namespace Db */
} /* namespace TkResolver */




#endif /* __TK_DB_UI_LOGIN_H__ */
