/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#ifndef __TK_PSEUDO_RANDOM_H__
#define __TK_PSEUDO_RANDOM_H__

#include <string>
#include <vector>

#include "randomness.h"
#include "retriever_registry.h"

namespace TkResolver {

  namespace Random {

    class PseudoRandom : public Retriever
    {
    private:
      static char   _state[256];
      //static char * _old_state;
      static bool   _state_initialised;

      static void initialise_state();
    protected:
      virtual Buffer * retrieve();
    public:
      PseudoRandom(unsigned chars);
      ~PseudoRandom();
    };

    class PseudoRandomType : public RetrieverType
    {
    public:
      virtual bool is_true_randomness();
      virtual unsigned get_preferred_block_size();
      virtual Retriever * new_retriever(unsigned count);
    };

  };

};


#endif /* __TK_PSEUDO_RANDOM_H__ */
