/*
 * tkresolver - Telekinesis testing software
 *
 * Copyright (C) 2004 Robert Ham <rah@bash.sh>
 *
 * GPL all the way, baby :)
 *
 */

#include "random_types.h"

using namespace TkResolver;
using namespace Random;

void
Bits:: get_data (BitChar ** mem_ptr, unsigned long * mem_len_ptr) const
{
  BitChar * mem;
  unsigned long mem_len;

  unsigned bit_count = size();

  mem_len = (bit_count / BITS_PER_CHAR) + (bit_count % BITS_PER_CHAR ? 1 : 0);

  mem = new BitChar[mem_len];

  unsigned char_index = 0;
  unsigned mem_index = 0;
  for (const_iterator iter = begin();
       iter != end();
       ++iter)
    {
      mem[mem_index] |= *iter << (BITS_PER_CHAR - char_index);

      ++char_index;
      if (char_index == BITS_PER_CHAR)
	{
	  ++mem_index;
	  char_index = 0;
	}
    }

  *mem_ptr = mem;
  *mem_len_ptr = mem_len;
}

std::string
Bits:: get_data () const
{
  BitChar * buffer;
  unsigned long buffer_len;

  get_data (&buffer, &buffer_len);

  std::string data(buffer, buffer_len);

  delete buffer;

  return data;
}
